<template>
<div class="board relative float-left w-full rounded-lg max-h-full" v-show="duplicates.length > 0">
    <div class="heading font-bold h-8 border-b rounded-t-lg pl-2 pt-1 bg-teal-300">
        <div class="title relative float-left text-teal-800">
            <div class="h-4 w-4 m-auto cursor-pointer inline-block">
                <img svg-inline class="fill-current inline-block" src="./pix/zond/shuffle.svg" />
            </div>
            <span v-if="report">
                Similar to #{{report.id}}
            </span>
        </div>
    </div>
    <div class="overflow-x-auto bg-white flex-grow border-teal-300 bg-teal-100 border-4">
        <div class="w-full min-w-full h-full overflow-hidden">
            <table class="relative w-full h-full flex flex-col">
                <tbody class="overflow-y-auto w-full">
                    <tr class="flex flex-row w-full" v-for="report in duplicates" :key="report.id">
                        <td class="px-2 py-2 whitespace-no-wrap">
                            <div class="flex flex-col items-center content-center">
                                <div class="flex-shrink-0 h-10 w-10">
                                    <img svg-inline src="./pix/virus-green.svg" class="w-full h-full" />
                                </div>
                                <div class="px-2 rounded-full mt-2" :class="[reportPalette(report.type.id).darkish.bg, reportPalette(report.type.id).lighter.text]">
                                    <span class="text-xs">{{report.id}}</span>
                                </div>
                            </div>
                        </td>
                        <td class="px-2 py-2 whitespace-no-wrap flex-grow w-full overflow-x-hidden">
                            <div class="text-sm leading-5 text-gray-900 whitespace-pre-line w-full">{{report.aoi.replace(/\$\d+\s*/, '')}}</div>
                            <ul class="">
                                <li class="list-none float-left mr-1 w-auto mt-1" v-for="(value, key) in report.properties" :key="key" v-if="value.length && !ignored.includes(key)">
                                    <div class="tag text-xs inline-block flex flex-row" :class="[reportPalette(report.type.id).darker.text]">
                                        <span class="key px-2 rounded-l-full capitalize" :class="[reportPalette(report.type.id).regular.bg, reportPalette(report.type.id).lighter.text]">{{key}}</span>
                                        <span class="value px-2 -ml-1 rounded-r-full truncate flex-grow max-w-xs" :class="[reportPalette(report.type.id).light.bg]" v-html="value" v-linkified></span>
                                    </div>
                                </li>
                            </ul>
                        </td>
                        <td class="px-2 py-2 whitespace-no-wrap" v-if="columns.includes('Time')">
                            <div class="text-sm leading-5 text-gray-900" v-tooltip="'Time of Interest'">{{report.toi}}</div>
                            <div class="text-xs leading-5 text-gray-500" v-tooltip="'Created'">{{report.created}}</div>
                        </td>
                    </tr>
                </tbody>
            </table>
        </div>
    </div>
</div>
</template>
<script>
import Vue from 'vue'
import axios from 'axios'
import axiosCancel from 'axios-cancel';
import {ThemeMixin} from './themes.js';
import './style.css';

axiosCancel(axios, {
    debug: false // default
});

export default{
    name: "WeeSpatialSimilarReportsViewer",
    props: {
        project: {
            type: Number,
            required: true
        }, 
        report: {
            type: Object
        }, 
        exclude: {
            type: Number
        }, 
        ignored: {
            type: Object,
            default: ['country', 'state']
        },
        columns: {
            type: Array,
            default: ['Area']
        },
        theme: {
            type: Object
        }
    },
    data(){
        return {
            reports: []
        }
    },
    mixins: [ThemeMixin],
    created(){
        if(this.report){
            this.load(this.report.aoi.replace(/\s+/gm, ' '));
        }
    },
    watch: {
        report(n, o){
            if(n){
                this.load(n.aoi.replace(/\s+/gm, ' '));
            }else{
                this.reports = [];
            }
        }
    },
    methods: {
        load(aoi){
            let self = this;
            axios.get(this.similarityUrl+aoi).then(function(response){
                self.reports = response.data.reports;
            }).catch(function(error){
                console.log(error);
            });
        }
    },
    computed: {
        duplicates: function(){
            return this.reports.filter(r => r.id != this.report.id);
        },
        similarityUrl: function(){
            return '/reports/'+this.project+'/like/';
        }
    }
}
</script>
